2008-07-10 02:37 - Joshua Hoover

Status: New Start date: 2008-07-10

Priority: Normal Due date:  
Target version:    

Description

Summary

This is a patch for #277 that provides the ability to send messages to forums via email.  This gives Redmine a mailing list like

capability by utilizing the work done in #1110 (Allow email to create issue or add comment), which has been available since r1572. 

By enabling this functionality users can create new and reply to existing forum messages that will be sent out via email to all those

who are watching that forum.

Configuration

There are two areas of configuration for this feature.  One is how you get emails into Redmine and the other is an optional

configuration to set a different emission email address specifically for forum emails.

Receiving Forum Message Emails for Redmine Processing

In order to receive emails into Redmine the documentation found here should be used.  This documentation covers specific settings

for creating issues within Redmine.  The only issue attribute that applies to this patch is the project attribute.  If you set the project

attribute.  I have done my functional testing using the IMAP setup.  The rake command looks something like this:

rake redmine:email:receive_imap host=imap.domain.com port=XXX ssl=true username=username@domain.co

m password=password_here RAILS_ENV=_production_

 Using the IMAP setup, you must schedule the rake command to run on a regular basis using cron or another job scheduling

mechanism.

Forum Emission Email Address

If you want to use a different reply-to email address for forum messages than you use for other emails sent from Redmine, then you'll

need to do the following:

1. Login to your Redmine instance as an Administrator

2. Click the Administration link at the top of the page

3. Click on the Settings link

4. Click on the Email Notifications tab

5. Enter the email address for forum emails in the Forum emission email address field

This email address should go to the email account receiving forum emails (configured above in the Receiving Forum

Message Emails for Redmine Processing section)

6. Click the Save button

User Documentation

The following describes how to make use of the email to forum functionality.

How to Create a New Forum Message via Email

In order to create a new forum message, you simply address an email to the email address specified in either the

Adminitration->Settings->Email Notifications Forum emission email address field (if populated) or the Emission email address (if the

the Forum emission email address field is not populated).  The subject of the email should be in the format of:

[Project Name - Forum Name] Forum message subject goes here
The format of the email body is not important.  The script that processes the forum emails is setup to determine the project and forum

names based on the email subject.

How to Reply to a Forum Message via Email

This is pretty simple. When you receive an email of a forum message you simply reply to the message and write your reply in the

body of the email.  One important thing to note is that you SHOULD NOT change the subject line if you want the email to be

recognized as a reply to an existing forum message.  The script that processes the forum emails is setup to determine the original

forum message being replied to by the portion of the subject that follows the square brackets.

Receive Forum Message Emails in Your Email Inbox

In case it's not clear how you receive forum messages, I'm adding that info here.  The best way to subscribe to receive emails for a

particular forum is to:

1. Click on the Forums tab in Redmine

2. Click on the name of the forum you want to subscribe to

3. Click on the Watch link so that the star icon turns yellow

You can also subscribe to all forums (and all other Redmine email notifications) by clicking on the My account link in the upper right

hand of the page and then select For any event on all my projects from the drop down menu under the Email notifications section.

Related issues:

Related to Redmine - Defect #7790: wrong assigning via email created message Closed 2011-03-05

Related to Redmine - Feature #15141: Incoming emails without redmine subject ... New

Related to Redmine - Feature #16006: Include attachments in forum post notifi... Closed

Associated revisions

Revision 2289 - 2009-01-19 20:03 - Jean-Philippe Lang

Allow email to reply to a forum message (#1616).

Revision 2294 - 2009-01-21 19:22 - Jean-Philippe Lang

Accept replies to forum messages by subject recognition (#1616).

History

#1 - 2008-07-10 03:08 - Joshua Hoover

- File feature_277_mailing_list_forum_integration_with_test_fixtures.diff added

My initial diff didn't have the test fixtures needed to run the unit tests.

#2 - 2008-11-11 10:35 - Jean-Philippe Lang

- Target version deleted (0.8)

#3 - 2008-11-11 21:50 - Joshua Hoover

I've had this patch running using IMAP for about a 35 user instance of Redmine without problems.  Any chance this gets into Redmine in the future? :)

#4 - 2009-01-05 19:35 - Brad Schick

Would be nice to have this. Seems rather surprising that Redmine supports email integration for issues, but not for forums since forums integration

would appear simpler.

#5 - 2009-01-07 05:13 - Andreas Huggel

+1 for this, I think this is needed to complete #1110: Currently, with email for issues enabled, if a user replies to a forum post, the email ends up

creating a new issue. I'll wait for this feature before turning on any email support.

Besides, at least in my project, there is more traffic in the forum than the issue tracker and of the 270 users some prefer a forum and others,

especially people who are involved in several projects, prefer a mailing-list interface. I'd like to make it as easy as possible for both camps to

contribute.

#6 - 2009-01-11 16:04 - Andreas Huggel

Just to stress again that this is a real requirement, please see: http://uk.groups.yahoo.com/group/exiv2/message/1501

After announcing the intention to change, I am now finding myself justifying the switch from a Yahoo group to a forum. Those who are challenging the
decision are an important user and a key contributor.

There has been no feedback from the project team here since Jean-Philippe removed this issue from the 0.8 roadmap. It would be good to know what

the plan is for this issue. Is there any non-obvious constraint that's holding this back?

#7 - 2009-01-11 16:12 - Jerome Vanthournout

+1

#8 - 2009-01-12 04:56 - Eric Davis

- % Done changed from 100 to 0

Andreas Huggel wrote:

There has been no feedback from the project team here since Jean-Philippe removed this issue from the 0.8 roadmap. It would be good to know

what the plan is for this issue. Is there any non-obvious constraint that's holding this back?

 I"m sorry if there wasn't a reason let when it was removed from 0.8.  We dropped a bunch of features because we wanted to get 0.8 out in 2008 and it

was accumulating too many features and the release date kept slipping.  I haven't checked the patch but I think this feature could be added to 0.9. 

My personal goals with 0.9 is adding in better automation and integration with external tools and this is right in line with that goal.

#9 - 2009-01-19 21:30 - Jean-Philippe Lang

r2289 adds ability to reply to forum messages. The subject of the reply can be changed since the application will use the In-Reply-To and References

headers to determine the message that the email replies to.

Concerning message creation via email, I think that having to use the syntax [Project Name - Forum Name] in the email subject can be cumbersome.

What about assigning an (optional) email address to each forum? This way, users would just have to email to this address to post a message.

#10 - 2009-01-20 00:03 - Joshua Hoover

Jean-Philippe,

I agree that forcing the syntax of [Project Name - Forum Name] in the email subject is cumbersome. The issue I ran into with using "References"

headers was that I couldn't seem to reliably get them to stay intact when replying via clients like MS Outlook. If this technique works then that's

definitely the way to go.

Creating an email address for each forum is probably the safest and most user friendly way to handle things. However, if you setup a lot of forums

across projects, there is the overhead of (manually and separately from setting up the forum in Redmine) setting up all those different email inboxes.

Great work on all of this!

#11 - 2009-01-20 00:11 - Arnaud Martel

Jean-Philippe Lang wrote:

Concerning message creation via email, I think that having to use the syntax [Project Name - Forum Name] in the email subject can be

cumbersome. What about assigning an (optional) email address to each forum? This way, users would just have to email to this address to post

a message.

 First, many thanks for redmine. It's really a very nice application and I'm using it everyday.

I'm working in a company where it's not very easy to create email addresses. Today, I have about 50 projects using Redmine and at least 2 forums

per project. So, having an email address for each forum would be very very difficult for me... What I like in this patch (and I'm using it): I can let users

manage their own projects, without having to create anything (except project itself and the associated repository). From my point of view, it's very

flexible this way. Another good solution is to allow the 2 options (patch AND email address)... ;-)

Arnaud

#12 - 2009-01-20 04:03 - Andreas Huggel

Concerning message creation via email, I think that having to use the syntax [Project Name - Forum Name] in the email subject can be

cumbersome. What about assigning an (optional) email address to each forum? This way, users would just have to email to this address to post

a message.

 Thanks for looking into this. I support the idea of having an email address for each forum, that will make posting very straightforward.

#13 - 2009-01-20 06:41 - Andreas Huggel

Will an anonymous user be able to post to the forums using these email addresses? If that should be possible at all, maybe an additional permission
to enable anonymous posting by email is required (disabled by default).

#14 - 2009-01-21 19:28 - Jean-Philippe Lang

The issue I ran into with using "References" headers was that I couldn't seem to reliably get them to stay intact when replying via clients like MS

Outlook.

 Indeed. I've added subject parsing too in r2294 (topic id was added to the notification subject to identify the topic without ambiguity).

#15 - 2009-11-12 07:20 - Hiro SHINOHARA

Is this work with a recent version? It wasn't on my Redmine 0.8.5.

I fixed some part of code to use this cool patch.

<a href="http://www.messaliberty.com/2009/11/how-to-use-email-to-create-and-reply-to-forums-on-redmine/">How To Use Email To Create And

Reply To Forums on Redmine « messaliberty</a>

#16 - 2009-11-28 16:31 - Andreas Huggel

Any chance this can make it into 0.9?

Thanks

#17 - 2010-05-20 12:46 - Andreas Huggel

Would be great to see this in 1.0!

Thanks

#18 - 2011-02-15 00:33 - Dave Clements

+1

#19 - 2011-02-15 06:05 - Phil Garcia

+2

#20 - 2011-03-07 12:27 - Ladislav Nesnera

Hie

We would like to migrate our environment to Redmine completely. Forum seems have ability to substitute our current email conferences. Can you

update this patch to the latest stable (1.x), please. Thanks a lot

#21 - 2011-03-25 11:26 - Hans Bangkok

+1

I agree it's important to encourage participation by those who are used to mail-lists - they're often more technically proficient than those who prefer

forums.

#22 - 2011-04-06 17:04 - Stefan Bellus

+1!

Has somebody patch for 1.2.0?

I want to use it to announce new release for all that subscribe for this information as watchers (not only to project members).

My project is library that is used by other teams. I don't know who use it. I have to make possible that all teams that uses my library can get

information about new releases/important bug-fixes. I think forum can be right solution.

I will release my library on Hudson and let hudson to send mail to add new topic in forum "Releases".

#23 - 2011-04-07 10:40 - Stefan Bellus

- File forum_message_creation_by_mail.patch added

I made my first patch on linux for redmine.

It is my first code in rubby, and I am very sorry that it is not under test. I have only gedit :).

Patch "forum_message_creation_by_mail.patch" adds forum message creation by email (be sure that user in "from email property" has permission to

edit forums) to http://redmine.rubyforge.svn/tags/1.1.2/app/models/mail_handler.rb.

to patch mail_handler.rb go to redmine directory and execute command

patch -p0 < forum_message_creation_by_mail.patch

#24 - 2011-09-10 06:53 - Robert Hailey

At least half of this ticket seems to be done, because I just tried replying to a forum post on 1.1.3 and it seems to work. ???
#25 - 2011-11-28 04:30 - Mischa The Evil

- Category changed from Forums to Email receiving

#26 - 2013-07-24 12:33 - Christian Burger

- File 2.3.2-forum_message_creation_by_mail.patch added

I have written a patch which allows to submit new forum messages via e-mail for Redmine version 2.3.2. No testing is implemented and the format is

slightly extended: You don't have to say which project the forum is part of:

[Project - Forum] New message subject

and

[Forum] New message subject

are both valid formats. In the latter case the corresponding project is either taken from the default setting or as in my case set through 

MailhandlerSubAddress.

And if someone is set CC or TO in the mail, he/she is added to the watchers' list. This happens without any regard for permissions; meaning there is

no "allowed to add watcher to forum message" permission. Anyone who can post forum messages can do it.

I would implement tests, but I have doubts that my patch will ever find its way into the main repository. I know: Without tests it will never happen. But it

seems to me, that the method of how to recognize new forum posts is a bit unclear.

I like the mail address tag idea of MailhandlerSubAddress: you could directly address a forum with an identifier "abc" which is part of a project with

identifer "def" via redmine+def+forum+abc@example.com.

Of course, mail address tags are not supported by every MTA and at least one uses a "-" as a separator. So, not very platform independent. But as a

fallback you could put the suffix

"def+forum+abc" from "redmine+def+forum+abc@example.com"

into the subject like this

"[def+forum+abc] some new topic"

#27 - 2014-02-01 20:52 - T. Hauptman

I also needed this functionality. I was able to emulate a mailing list using #15141 with specific addresses going to different boards.

I later implemented boards sending out on different addresses, specified in config/configuration.yml

#28 - 2014-02-28 08:54 - Toshi MARUYAMA

- Related to Feature #15141: Incoming emails without redmine subject line are posted as a new message added

#29 - 2014-02-28 08:55 - Toshi MARUYAMA

- Related to Feature #16006: Include attachments in forum post notifications added

#30 - 2014-05-20 14:27 - Peter L.

Please add this!!! Thanks!!

#31 - 2018-05-21 16:10 - Javier Sevilla

Peter L. wrote:

Please add this!!! Thanks!!

 Is this functionality created? I reply all the forum messages and appear without problem, but I can't create a new topic/message in the forum.

I try to send a message with all the subject combinations described in this thread with no result, allway generates a Bug issue....

Please, help me.

Files

feature_277_mailing_list_forum_integration.diff 8.02 KB 2008-07-10 Joshua Hoover

feature_277_mailing_list_forum_integration_with_test_fixtures.diff 16.7 KB 2008-07-10 Joshua Hoover

forum_message_creation_by_mail.patch 2.65 KB 2011-04-07 Stefan Bellus

2.3.2-forum_message_creation_by_mail.patch 2.18 KB 2013-07-24 Christian Burger
